#include <iostream>

#include "./common.h"
#include "./types.h"
#include "./geom.h"

using namespace std;

extern int window_width;
extern int window_height;
extern float window_aspect;

void DrawTriangles() {
  glColor3f(1, 0, 0);
  glBegin(GL_TRIANGLES);
  glVertex3f(-10, 0, 10);
  glVertex3f(10, 0, 10);
  glVertex3f(0, 15, 10);
  glEnd();

  glColor3f(0, 1, 0);
  glBegin(GL_TRIANGLES);
  glVertex3f(-10, 0, 0);
  glVertex3f(10, 0, 0);
  glVertex3f(0, 15, 0);
  glEnd();

  glColor3f(0, 0, 1);
  glBegin(GL_TRIANGLES);
  glVertex3f(-10, 0, -10);
  glVertex3f(10, 0, -10);
  glVertex3f(0, 15, -10);
  glEnd();
}

void Display1() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // Quick example to see what is going on
  // perspective
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(40.0,window_aspect,1,1500);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(15, 20, 45,
            0, 5, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display2() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) three triangles
  //  B) one triangle
  //  C) nothing
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-5, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display3() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) same as Display2
  //  B) triangle is smaller
  //  C) triangle is larger
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-5, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  // z value changed from 45 to 90
  gluLookAt(0, 0, 90,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display4() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) same as Display3
  //  B) triangle is smaller
  //  C) triangle is larger
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  glOrtho(-5, 10, 0, 15, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  // z value changed from 90 to 300
  gluLookAt(0, 0, 300,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display5() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) same as Display3
  //  B) triangle is smaller
  //  C) triangle is larger
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  // changed from glOrtho(-5, 10, 0, 15, 0, 200);
  glOrtho(-10, 10, 0, 5, 0, 200);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  // z value changed from 300 to 45
  gluLookAt(0, 0, 45,
            0, 0, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display6() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) three triangles of the same size
  //  B) three triangles of differing size
  //  C) one triangle
  //  D) none of the above
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  gluPerspective(40.0,window_aspect,1,1500);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(15, 20, 45,
            0, 5, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display7() {
  glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);

  // What is rendered?
  //  A) same as Display6
  //  B) triangles are smaller
  //  C) triangles are larger
  //  D) triangles are of a different color
  glMatrixMode(GL_PROJECTION);
  glLoadIdentity();
  // Changed from gluPerspective(40.0,window_aspect,1,1500);
  gluPerspective(20.0,window_aspect,1,1500);

  glMatrixMode(GL_MODELVIEW);
  glLoadIdentity();
  gluLookAt(15, 20, 45,
            0, 5, 0,
            0, 1, 0);

  DisableLighting();
  DrawAxis();
  DrawTriangles();

  glFlush();
  glutSwapBuffers();
}

void Display8() {
}

void Display9() {
}

void Display10() {
}

void Display11() {
}

void Display12() {
}

void Display13() {
}
